# Perceptron Python Package

## References - 

* [Official python docs from PYPI](https://packaging.python.org/en/latest/tutorials/packaging-projects/)

A simple implementation of the Perceptron algorithm using only Python and NumPy. This notebook demonstrates the foundational concepts behind binary classification through a hands-on example using the AND logic gate.

🧠 What is a Perceptron?
The Perceptron is one of the earliest types of artificial neural networks, used for binary classifiers. It performs classification by computing a weighted sum of inputs and applying an activation function.

📁 Project Structure
Perceptron.ipynb: Main notebook with complete implementation and usage demonstration.

Trains the model on the AND logic gate dataset.

Includes methods for:

Forward propagation

Weight updates

Loss calculation

Model saving/loading

🚀 Features
Implementation of the perceptron class from scratch (no ML libraries).

Visual inspection of the training process.

Save and reload trained models using joblib.